#include <string.h>

#include <config.h>

/* Configure arguments. */
static char ARGS[] = " 'CPP=cpp' 'CC=mpicc -m64' 'CFLAGS=-g -O2' 'CXX=mpic++ -m64' 'FC=mpif90 -m64' 'FCFLAGS=-ffree-form -m64 -g -ffree-line-length-none -O2 -fPIC' 'F77=mpif90 -m64' 'FFLAGS=-ffixed-form -m64 -g -ffree-line-length-none -O2 -fPIC' '--with-moduledir=/include' '--disable-bindings' '--with-libxc' '--disable-internal-libxc' '--with-libxc-libs=-L/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/libxc-gcc48/include -lxc -lxcf90' '--with-libxc-incs=-I/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/libxc-gcc48/include' '--with-etsf-io' '--with-etsf-io-path=/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/etsf_io-gcc48' '--with-netcdf' '--with-netcdf-path=/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/netcdf-gcc48' '--with-scalapack' '--with-scalapack-path=/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/mkl/intel64/lib' '--enable-pseudo' '--disable-internal-libsgpu' '--enable-internal-libyaml' '--with-ext-linalg=-L/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/mkl/intel64/lib' '--with-ext-linalg-path=-Wl,--start-group -lmkl_scalapack_lp64 -lmkl_intel_lp64 -lmkl_gnu_thread -lmkl_core -lmkl_blacs_intelmpi_lp64 -lmkl_vml_p4n -Wl,--end-group -lpthread -lgomp -lm' '--enable-binaries' '--prefix=/cea/home/abinit/abinit/BZR/TORRENT/BIGDFT/BUILD'";

/* Compilers. */
static char CC[]  = "mpicc -m64";
static char FC[]  = "mpif90 -m64";
static char CXX[] = "mpic++ -m64";

/* Compiler flags. */
static char CFLAGS[]   = "-g -O2";
static char FCFLAGS[]  = "-ffree-form -m64 -g -ffree-line-length-none -O2 -fPIC";
static char CXXFLAGS[] = "-g -O2";
static char CPPFLAGS[] = "";

/* Linker stuff. */
static char LD[]        = "@LD@";
static char LDFLAGS[]   = " -L/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/etsf_io-gcc48/lib -L/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/netcdf-gcc48/lib -Wl,--start-group -lmkl_scalapack_lp64 -lmkl_intel_lp64 -lmkl_gnu_thread -lmkl_core -lmkl_blacs_intelmpi_lp64 -lmkl_vml_p4n -Wl,--end-group -lpthread -lgomp -lm -L$(top_builddir)/libxc-2.0.x/src/.libs -L$(top_builddir)/libABINIT/src ";
static char LIBS[]      = "-lrt ";
static char LIBS_DEPS[] = "-labinit -lxcf90 -lxc    -letsf_io_utils -letsf_io -lnetcdff -lnetcdf -L/cea/home/pmcdev/pmcdev/RedHat-6-x86_64/mkl/intel64/lib  $(top_builddir)/yaml-0.1.4/src/.libs/libyaml.a   ";

#define TRUNCATED "(...)"


void FC_FUNC_(bigdft_config_get_user_args, BIGDFT_CONFIG_GET_USER_ARGS)
     (char *args, unsigned int *ln, int args_ln)
{
  memset(args, ' ', sizeof(char) * *ln);
  if (sizeof(ARGS) <= *ln)
    memcpy(args, ARGS, sizeof(ARGS)-1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(args, TRUNCATED, sizeof(TRUNCATED)-1);
}

void FC_FUNC_(bigdft_config_get_compilers, BIGDFT_CONFIG_GET_COMPILERS)
     (char *cc, char *fc, char *cxx, unsigned int *ln, int cc_ln, int fc_ln, int cxx_ln)
{
  memset(cc, ' ', sizeof(char) * *ln);
  if (sizeof(CC) <= *ln)
    memcpy(cc, CC, sizeof(CC)-1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(cc, TRUNCATED, sizeof(TRUNCATED)-1);

  memset(fc, ' ', sizeof(char) * *ln);
  if (sizeof(FC) <= *ln)
    memcpy(fc, FC, sizeof(FC) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(fc, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(cxx, ' ', sizeof(char) * *ln);
  if (sizeof(CXX) <= *ln)
    memcpy(cxx, CXX, sizeof(CXX) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(cxx, TRUNCATED, sizeof(TRUNCATED) - 1);
}

void FC_FUNC_(bigdft_config_get_compiler_flags, BIGDFT_CONFIG_GET_COMPILER_FLAGS)
     (char *cflags, char *fcflags, char *cxxflags, char *cppflags, unsigned int *ln,
      int c_ln, int fc_ln, int cxx_ln, int cpp_ln)
{
  memset(cflags, ' ', sizeof(char) * *ln);
  if (sizeof(CFLAGS) <= *ln)
    memcpy(cflags, CFLAGS, sizeof(CFLAGS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(cflags, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(fcflags, ' ', sizeof(char) * *ln);
  if (sizeof(FCFLAGS) <= *ln)
    memcpy(fcflags, FCFLAGS, sizeof(FCFLAGS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(fcflags, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(cxxflags, ' ', sizeof(char) * *ln);
  if (sizeof(CXXFLAGS) <= *ln)
    memcpy(cxxflags, CXXFLAGS, sizeof(CXXFLAGS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(cxxflags, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(cppflags, ' ', sizeof(char) * *ln);
  if (sizeof(CPPFLAGS) <= *ln)
    memcpy(cppflags, CPPFLAGS, sizeof(CPPFLAGS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(cppflags, TRUNCATED, sizeof(TRUNCATED) - 1);
}

void FC_FUNC_(bigdft_config_get_linker, BIGDFT_CONFIG_GET_LINKER)
     (char *ld, char *ldflags, char *libs, char *libs_deps, unsigned int *ln,
      int ld_ln, int ldflags_ln, int libs_ln, int libs_deps_ln)
{
  memset(ld, ' ', sizeof(char) * *ln);
  if (sizeof(LD) <= *ln)
    memcpy(ld, LD, sizeof(LD) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(ld, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(ldflags, ' ', sizeof(char) * *ln);
  if (sizeof(LDFLAGS) <= *ln)
    memcpy(ldflags, LDFLAGS, sizeof(LDFLAGS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(ldflags, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(libs, ' ', sizeof(char) * *ln);
  if (sizeof(LIBS) <= *ln)
    memcpy(libs, LIBS, sizeof(LIBS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(libs, TRUNCATED, sizeof(TRUNCATED) - 1);

  memset(libs_deps, ' ', sizeof(char) * *ln);
  if (sizeof(LIBS_DEPS) <= *ln)
    memcpy(libs_deps, LIBS_DEPS, sizeof(LIBS_DEPS) - 1);
  else if (*ln > sizeof(TRUNCATED))
    memcpy(libs_deps, TRUNCATED, sizeof(TRUNCATED) - 1);
}
